#ifndef DUNE_PERFTOOL_SUMFACT_TRANSPOSEREG_HH
#define DUNE_PERFTOOL_SUMFACT_TRANSPOSEREG_HH

#include<dune/perftool/common/vectorclass.hh>

/**
 * Transpose a 4x4 matrix given by 4 vector registers (efficiently)
 */

void transpose_reg(Vec4d& a0, Vec4d& a1, Vec4d& a2, Vec4d& a3)
{
  Vec4d b0,b1,b2,b3;
  b0 = blend4d<0,4,2,6>(a0,a1);
  b1 = blend4d<1,5,3,7>(a0,a1);
  b2 = blend4d<0,4,2,6>(a2,a3);
  b3 = blend4d<1,5,3,7>(a2,a3);
  a0 = blend4d<0,1,4,5>(b0,b2);
  a1 = blend4d<0,1,4,5>(b1,b3);
  a2 = blend4d<2,3,6,7>(b0,b2);
  a3 = blend4d<2,3,6,7>(b1,b3);
}

#if MAX_VECTOR_SIZE >= 512

void transpose_reg(Vec8d& a0, Vec8d& a1, Vec8d& a2, Vec8d& a3)
{
  Vec8d b0, b1, b2, b3;
  b0 = blend8d<0,4,8,12,1,5,9,13>(a0, a1);
  b1 = blend8d<1,5,9,13,3,7,11,15>(a0, a1);
  b2 = blend8d<0,4,8,12,1,5,9,13>(a2, a3);
  b3 = blend8d<1,5,9,13,3,7,11,15>(a2, a3);
  a0 = blend8d<0,1,2,3,8,9,10,11>(b0, b2);
  a1 = blend8d<4,5,6,7,12,13,14,15>(b0, b2);
  a2 = blend8d<0,1,2,3,8,9,10,11>(b1, b3);
  a3 = blend8d<4,5,6,7,12,13,14,15>(b1, b3);
}

#endif

#endif
